Skip to main content

Overview

Webhooks allow partners to subscribe to real-time notifications of specific events occurring within the Tesouro system. Tesouro sends these events via HTTPS as a JSON payload to an endpoint set by you. You can then use these notifications to execute actions in your backend systems.

How to subscribe to webhooks

To start receiving webhooks, follow these steps:
  1. Identify the events you want to monitor.
  2. Create the webhook listener endpoint on your server.
  3. Subscribe to the desired events by calling POST /webhook-subscriptions.
  4. Handle the requests from Tesouro.

1. Identify the events you want to monitor

Currently, Tesouro triggers notifications for the following objects and events:

2. Create a webhook listener endpoint on your server

To receive webhooks requests from Tesouro, you must set up an HTTPS endpoint on your server. You can use one endpoint to handle several different event types at once or set up individual endpoints for specific events.
If you want to receive webhooks from both production and sandbox environments, we recommend that you use separate webhoook listener endpoints for these environments.
Your webhook listener endpoint must be accessible from the public Internet, accept POST requests, and respond with HTTP status code 200 to acknowledge successful receipt of the webhook. Tesouro webhooks do not follow redirects, so make sure to specify a direct URL when subscribing to webhooks. You can expect a JSON request body with the following structure:
The possible values for action are listed in the table above.

3. Subscribe to webhooks

To subscribe to the desired Tesouro webhook events, call POST /webhook-subscriptions with the request body containing your webhook listener url and the events you want to be notified about. If you omit event_types, Tesouro will notify you about all events of the specified object_type.
The successful response contains the id assigned to this webhook subscription and the secret that you can use to verify webhook signatures:

4. Handle the requests from Tesouro

To handle the events sent by Tesouro, parse the body of the requests that arrive at your webhook endpoint. You can use the entity_id, object_type, and object_id fields to identify the affected organization and the object that was changed. For example, the following webhook event means that an organization with ID 3fa85f64-5717-4562-b3fc-2c963f66afa6 created a new counterpart and that counterpart was assigned ID f0535ce9-8cdd-4f5c-bfe2-6a7f1429fbbe:
To get the full details of the created counterpart, you can then call GET /counterparts/f0535ce9-8cdd-4f5c-bfe2-6a7f1429fbbe.

Retry policy

If your webhook listener endpoint returns any HTTP status code other than 200 - for example, 204 or 301 - Tesouro considers the webhook delivery unsuccessful. We automatically retry sending the webhook for a total of a week. The time interval between the retries follows this schedule:
  • 2 minutes
  • 5 minutes
  • 10 minutes
  • 15 minutes
  • 30 minutes
  • 1 hour
  • 2 hours
  • 4 hours
  • 8 hours
  • After that, the webhook will be retried every 8 hours
If the unavailability persists for a total of a week, Tesouro automatically disables the corresponding webhook subscription and all further requests are canceled, including for new events. Additionally, Tesouro sends an email notification to the partner’s email address informing them of the disabled webhook subscription and providing details for further action. After resolving the issues with the webhook listener endpoint, the partner can manually re-enable the affected webhook subscription. Partners can use GET /events to get the missed webhook events from the period when their webhook listener was unavailable:
Tesouro uses an “at least once” delivery policy for all webhook events. This means that:
  • Events may occasionally be delivered more than once.
  • Retries can occur if your endpoint fails to acknowledge receipt (e.g., non-200 response or timeout).
  • When retried, the event will include the same unique id as the original delivery.
Because of this, event deduplication is required on the customer’s side. You should use the id to identify and ignore duplicates.

Review webhook deliveries

Tesouro keeps a log of delivery attempts for all webhook events that partners are subscribed to. A partner can call GET /webhook-deliveries to access the webhook delivery log for the events of a specific organization:
The response contains information about how many times an event was triggered, the event ID, the status code of the last attempt, and whether or not the final attempt was successful. Available data is limited to the last three months.

List all webhook subscriptions

To get a list of your existing webhook subscriptions, call GET /webhook-subscriptions. You can optionally filter the list by the webhook event type and the subscription date. For example:
  • Get all subscriptions for entity events:
  • Get all subscriptions created on or after September 1, 2024:

Retrieve a webhook subscription

To get the details of a specific webhook subscription, call GET /webhook-subscriptions/{webhook_subscription_id}.

Update a webhook subscription

To update an existing webhook subscription, call PATCH /webhook-subscriptions/{webhook_subscription_id}. You can update the webhook listener URL and the list of events to get notifications for.

Disable a webhook subscription

All webhook subscriptions are enabled by default but get automatically disabled if Tesouro cannot connect to the webhook listener URL after a series of retries. You can also disable a webhook subscription manually by calling POST /webhook-subscriptions/{webhook_subcription_id}/disable:
While a webhook subscription is disabled, the associated events are not triggered and therefore are not included in historical webhook data available via GET /events and GET /webhook-deliveries.

Enable a webhook subscription

To re-enable a disabled webhook subscription, call POST /webhook-subscriptions/{webhook_subscription_id}/enable:

Delete a webhook subscription

To delete a webhook subscription, call DELETE /webhook-subscriptions/{webhook_subscription_id}. You will stop receiving webhooks for the events listed in that subscription.